#!PERL_ABSOLUTE_PATH
#
#This file is part of NNIPF(Version 0.06-release):SPAM mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#############################################################################
if (($start=rindex($0,"/")) >-1) {
        $ME=substr($0,$start+1);
        $Cmdpath=substr($0,0,$start);
}else{ $ME=$0; $Cmdpath=".";}
push @INC, "$Cmdpath/CONF", "$Cmdpath/PERL";
require 'conf.pl';
require 'analyze.pl';
require 'header.pl';
use Encode;
use Encode::Guess qw/ shiftjis euc-jp 7bit-jis /;

$DayFrom="0";
$DayTo="1";
$DayFixed=0;

#initialization
 HEADER::bRead($BOUNDARY);

if ($ENV{'REQUEST_METHOD'} eq "POST") {
   read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
        @a = split(/&/, $query_string);
        foreach $x (@a) {
                ($name, $value) = split(/=/, $x);
		$name =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		if (($DayFixed eq 0)&&($name eq "DT")) {
			$DayTo=$value;
		}elsif (($DayFixed eq 0)&&($name eq "DF")) {
			$DayFrom=$value;
		}elsif ($name eq "DP") {
			if ($value<8){
			$DayFrom=$value-1;
			$DayTo=$value;
			$DayFixed=1;
			}
		}elsif ($name eq "DIR") {
			$dir=$value;
		}elsif ($value eq "N") {
#### "Normal" Maildir/** -> Maildir/new
			$filename="$MAILDIR/$dir/$name";
			$RCV=HEADER::rvf($filename);
			$OIP=HEADER::officialIP($RCV);
			if ($OIP ne ""){ANALYZE::IpDictAddExclusive($OIP,$GOODIP,$BADIP);}
			if ($dir eq "$TMPNAME") {
			    if ($TOCELLPHONE ne "")
			            {system("cat $filename |$TOCELLPHONE");}
			    $dfilename="$NEW/$name";
			    rename $filename, $dfilename;
			}
		  } elsif ($value eq "S") {
#### "Spam" Maildir/** -> TRASH
			$filename="$MAILDIR/$dir/$name";
			$RCV=HEADER::rvf($filename);
			$OIP=HEADER::officialIP($RCV);
			if ($OIP ne ""){ANALYZE::IpDictAddExclusive($OIP,$BADIP,$GOODIP);}
			$dfilename="$TRASH/$name";
			rename $filename, $dfilename;
		  } elsif ($value eq "R"){
#### "Normal" TRASH -> Maildir/new
			$filename="$TRASH/$name";
			$RCV=HEADER::rvf($filename);
			$OIP=HEADER::officialIP($RCV);
			if ($OIP ne ""){ANALYZE::IpDictAddExclusive($OIP,$GOODIP,$BADIP);}
			if ($TOCELLPHONE ne "")
			     {system("cat $filename |$TOCELLPHONE");}
############# This may be changed################
			$name =~ s/:2,.*//;
#################################################
			$dfilename = "$NEW/$name";
			rename $filename, $dfilename;
		  } elsif ($name eq "ABIP"){
##### Add Bad IP
			     ANALYZE::IpDictAddExclusive($value,$BADIP,$GOODIP);
		  } elsif ($name eq "AGIP"){
##### Add Good IP
			     ANALYZE::IpDictAddExclusive($value,$GOODIP,$BADIP);
		  } elsif ($value eq "AGIP"){
##### Add Good IP
			     $RCV=HEADER::rvf("$TRASH/$name");
			     $OIP=HEADER::officialIP($RCV);
			     ANALYZE::IpDictAddExclusive($OIP,$GOODIP,$BADIP);
		  } elsif ($value eq "ABIP"){
##### Add Bad IP
			     $RCV=HEADER::rvf("$TRASH/$name");
			     $OIP=HEADER::officialIP($RCV);
			     ANALYZE::IpDictAddExclusive($OIP,$BADIP,$GOODIP);
		  } elsif ($name eq "MSG"){
##### Add Bad IP
 			open OUTbf,"> $BOUNDARY" or die "$BOUNDARY:$!";
			$value =~ s/\r//g;
			print OUTbf $value;
			close(OUTbf);
		        HEADER::bRead($BOUNDARY);
		  } 
	}
}elsif (($ENV{'REQUEST_METHOD'} eq "GET")&&(($QS=$ENV{'QUERY_STRING'}) ne "")) {
    @a = split(/&/, $QS);
    foreach $x (@a) {
                ($name, $value) = split(/=/, $x);
                if ($name eq "FILE") {
################# Read specified Mail
			$filename=$value;
print <<END_HTML1;
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift-JIS">
<TITLE>SHOW MAIL</TITLE>
<link rel="SHORTCUT ICON" href="./DOC/minilogo.ico">
</HEAD>
<BODY>
<DIV align=right><A href="./DOC/SHOWhelp.html">HELP</A></DIV><HR>
END_HTML1
################### Show MSG
    my $flag=0;
    if (($filename =~ /$CURNAME\//)||
        ($filename =~ /$TMPNAME\//)||
	($filename =~ /$TRASHNAME\//)){
	 $filename = $MAILDIR . "/" . $filename;$flag=1;
	}
    if ($flag){
open IN,$filename or die "$filename:$!";
$header= HEADER::HeaderAnalysis(*IN,*hBuf,0);
my $pat= $header->{'OIP'};
$pat =~ s:\.:\\\.:g;
$score=int($header->{'Dis'}*100);
# end of header reading
foreach $i (@hBuf){
        if ($i =~ /^(Subject|From|Reply-To):/) {
		$i=encode('shiftjis', decode('MIME-Header',$i));
                if ($i=~ /^(.*)(.\$B.*\(B)(.*)$/){
                  $one=$1;$two=$2;$c=$3; $c=~ s/</&lt;/g; $c=~ s/>/&gt;/g;
                  $Sfrm{$i}=sprintf("%s%s%s",$one,$two,$c);
                }else{
	          $Sfrm{$i}=~ s/&/&amp;/g;
                  $Sfrm{$i}=~ s/</&lt;/g;
	          $Sfrm{$i}=~ s/>/&gt;/g;
                }
                $i=encode('shiftjis',decode('Guess',$i));
	}else{
	     $i =~ s/&/&amp;/g; $i =~ s/</&lt;/g; $i=~ s/>/&gt;/g;
	     $i =~ s:(\[$pat\]):<font size="+2">\1</font>:g;
	     $i =~ s:\[([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)\]:<A href="$ME?IP=\1">\[\1\]</A>:g;

	   if ($i =~ /by ([A-z0-9._\-]+)/) {
		$by  = $1;
		if (HEADER::Checkb($by)){
		    if ($by ne $header->{'by'}) {
		       $i =~ s:($by):<font color=\#ff00ff>\1</font>:g;
		    }else{
		       $i =~ s:($by):<font color=red>\1</font>:g;
		    }
		}else{
		  $i =~ s:($by):<A href=\"$ME?MTAOB=\1\">\1</A>:g;
		}
	  }
	}
	print "$i<BR>\n";
}
print "<HR><PRE>\n";
	while(<IN>){
          $_ =encode('shiftjis',decode('Guess',$_));
	  $_ =~ s/&/&amp;/g; $_ =~ s/</&lt;/g; $_=~ s/>/&gt;/g;
          print "$_<BR>";
       }
       close(IN);
    }

print <<END_HTML2;
</PRE>
</BODY>
</HTML>
END_HTML2
		}elsif ($name eq "MTAOB"){
################# Add MTAOB 
print <<END_HTML3;
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift-JIS">
<TITLE>ADD $value in Boundary file?</TITLE>
<link rel="SHORTCUT ICON" href="./DOC/minilogo.ico">
</HEAD>
<BODY>
END_HTML3
 print "<A href=\"$ENV{'HTTP_REFERER'}\"> Back</A>";
 print "<form method=\"POST\" action=\"$ME\">\n";
 print "<textarea name=\"MSG\" cols=50 rows=10>\n";
 open INbf, $BOUNDARY or die "$BOUNDARY:$!";
 while(<INbf>){ $_ =~ s/\n//; print "$_\n"; }
 close(INbf);
 if ($value) {print "$value\n";}
 print "</textarea><BR>";
 print "<input type=submit value=\"ADD $value in Boundary file\">";
 print "</form>";

print <<END_HTML4;
</BODY>
</HTML>
END_HTML4
		}elsif ($name eq "IP"){
                    my $Ratio = -1;
                    chomp($IP=$value);
                    if ($IP =~ /[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/){
			    $Ratio=ANALYZE::distinctiveness($IP,0);
                    } else{
                            $IP="Input IP";
                    }
print <<END_OF_HTML5;
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS">
<TITLE>IP ADDR MANAGEMENT</TITLE>
<meta http-equiv="Pragma" content="no-cache">
<link rel="SHORTCUT ICON" href="./DOC/minilogo.ico">
</HEAD>
<BODY>
END_OF_HTML5
 print "<A href=\"$ENV{'HTTP_REFERER'}\"> Back</A>";
 print "<TABLE BORDER=0>\n";
 print "<TR VALIGN=top ALIGN=center>\n";

 print "<TD>\n";
 print "<form method=\"GET\" action=\"$ME\">";
 print "IP ADDRESS=<input type=text name=\"IP\" size=16 value=\"$IP\" ";
 if ($Ratio >=0) { print "disabled>\n";
                  printf("Distinctiveness= %f%%\n", $Ratio*100);
 }else{
  print ">\n";
  print "<input type=submit value=\"CHECK\">\n";
 }
 print "</form>\n";
 print "</TD></TR><TR>\n";

 if (($IP ne '127.0.0.1')&&(ANALYZE::IsPrivate($IP) eq 0) && ($Ratio ne 1.0)){
   print "<TD align=right>\n";
   print "<form method=\"POST\" action=\"$ME\">";
   print "<input type=\"hidden\" name=\"ABIP\" value=\"$IP\" >\n";
   print "<input type=submit value=\"AddBIP\">\n";
   print "</form>\n";
   print "</TD>\n";
 }

 if (($IP ne '127.0.0.1')&&(ANALYZE::IsPrivate($IP) eq 0) && ($Ratio ne 0.0)){
   print "<TD align=right>\n";
   print "<form method=\"POST\" action=\"$ME\">";
   print "<input type=\"hidden\" name=\"AGIP\" value=\"$IP\" >\n";
   print "<input type=submit value=\"AddGIP\">\n";
   print "</form>\n";
   print "</TD>\n";
 }
 print "</TR>\n";
 print "</TABLE>\n";
 if (($IP =~ /[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/) && ($IP ne '127.0.0.1')&&(ANALYZE::IsPrivate($IP) eq 0)){
	print "<PRE>\n";
	open wIN, "whois $IP|" or die "whois: $!";
	while (<wIN>) {print $_;}
	close wIN;
	print "</PRE>\n";
 }
 print <<END_OF_HTML6;
</BODY>
</HTML>
END_OF_HTML6

######################
	        }
	}
exit;
#################GET end
}

print <<END_OF_HTML1;
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS">
<TITLE>SPAM CONSOLE</TITLE>
<meta http-equiv=Refresh content=180>
<meta http-equiv="Pragma" content="no-cache">
<link rel="SHORTCUT ICON" href="./DOC/minilogo.ico">
</HEAD>
<BODY>
END_OF_HTML1
# print "<TABLE BORDER=0 align=>\n";
# print "<TR VALIGN=top ALIGN=center>\n";
# print "<TD>\n";
 print "<A HREF=\"./DOC/README-j.html\"> README </A>&nbsp;";
 print "<A HREF=\"./DOC/WEB-interface.html\"> HELP </A>&nbsp;";
 print "<A HREF=\"./DOC/MTAOBhowto.html\"> Received Field </A>&nbsp;";
 print "<A HREF=\"$ME?IP=\"> IP address check</A>&nbsp;";
 print "<A HREF=\"$ME?MTAOB=\"> Boundary File</A><HR>\n";
# print "</TD>"; 
# print "<TD>";
#Show Boundary File
# print "<form method=\"POST\" action=\"$ME\">\n";
# print "<textarea name=\"MSG\" cols=60 rows=3>\n";
# open INbf, $BOUNDARY or die "$BOUNDARY:$!";
# while(<INbf>){ $_ =~ s/\n//; print "$_\n"; }
# close(INbf);
# print "</textarea>";
# print "<BR>Boundary FILE";
# print "<input type=submit value=\"UPDATE\">";
# print "</form>";
# print "</TD></TR>";
# print "</TABLE>";

 DirRead("$TMP/",0,1000);
 DirRead("$CUR/",0,1000);
 DirRead("$TRASH/",$DayFrom,$DayTo);

print <<END_OF_HTML2;
</BODY>
</HTML>
END_OF_HTML2





############################################
sub DirRead {
  ($dir,$dayfrom, $dayto)=@_;
  my $endpos=length($dir);
  my $DIR;
  if (substr($dir,$endpos-1) eq "/") {$DIR=substr($dir,0,$endpos-1);}
  my $title=substr($DIR,rindex($DIR,"/")+1);
  
  my %Subj, %Sfrm, %Past, %Rfrm, %Dis;
  my @msg = ();
  my @result = ();
  
  # Init
  #
  my @Buf;
  my $now=time();
  my $Df=$dayfrom*86400;
  my $Dt=$dayto*86400;
  
  
  my @Result = ( );;
  my $header;
  
  ## Sort mails by time
  my @Msg = ( );
  opendir DH, $dir or die "$dir:$!";
  $count = 0;
  while (my $file = readdir DH) {
    next if $file =~ /^\.{1,2}$/;	
    $Pas = $now-substr($file,0,10);
    if (($Pas > $Df)&&($Pas <= $Dt)) {
      $Msg[$count++]=$file;
    }
  }
  closedir DH;
  @Result= sort { $b cmp $a } @Msg;
  
  $count = 0;
  foreach $file (@Result) {
    $Pas = $now-substr($file,0,10);
    $filename=$dir . $file;
    
    if (-e $filename){
      open IN, $filename or die "$filename:$!";
      $header= HEADER::HeaderAnalysis(*IN,*Buf,0);
      close(IN);
      # end of header reading

      if (($title ne "$CURNAME")||( $header->{'OIP'} ne "")&&
          ( $header->{'Dis'} >0.0)) {
        $Oip{$file}=$header->{'OIP'}; 
        $Past{$file}=$Pas; 
        $Dis{$file}=$header->{'Dis'};
        $Subj{$file}=$header->{'subject'}; 
        $Sfrm{$file}=$header->{'from'}; 
        $Rfrm{$file}=$header->{'Frm'}; 
        $result[$count++]=$file;
      }
    }
  }
  
  # ~/Maildir/cur or ~Maildir/tmp
  if ($title =~ /$CURNAME|$TMPNAME/) {
    if ($count>0){
      print "<H4>$title</H4>\n";
      print $#result+1, "items\n";
      print "<form method=\"POST\" action=\"$ME\">";
      print "<input type=\"hidden\" name=\"DIR\" value=\"$title\" >\n";
      print "<input type=submit>";
      print "<input type=reset>";
      print "<TABLE BORDER=4 align=>\n";
      
      foreach $i (@result) {
        ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(substr($i,0,10));
        $mon += 1;
        $year+=1900;
        $Sfrm{$i}=encode('shiftjis', decode('MIME-Header',$Sfrm{$i}));
        # This code is for non-mime-encoded From. Should be replaced############
        if ($Sfrm{$i}=~ /^(.*)(.\$B.*\(B)(.*)$/){
          $one=$1;$two=$2;$c=$3; $c=~ s/</&lt;/g; $c=~ s/>/&gt;/g;
          $Sfrm{$i}=sprintf("%s%s%s",$one,$two,$c);
        }else{
	  $Sfrm{$i}=~ s/&/&amp;/g;
          $Sfrm{$i}=~ s/</&lt;/g;
	  $Sfrm{$i}=~ s/>/&gt;/g;
        }
        $Sfrm{$i}=encode('shiftjis',decode('Guess',$Sfrm{$i}));
        ##########################################################################
        if ($Subj{$i}=~ /^=\?/) {$Subj{$i}=encode('shiftjis', decode('MIME-Header',$Subj{$i}));}
        if ($Subj{$i} =~ /^\s*$/) {
          $Subj{$i} = "**No Title**";
        }
        print "<TR><TD ROWSPAN=4>";
        print "<input type=\"radio\" name=\"$i\" value=\"S\">Spam<BR>";
        if ($title !~ /$CURNAME/) {
          print "<input type=\"radio\" name=\"$i\" value=\"N\">Nomal<BR>";
        }
        if ($title !~ /$TMPNAME/) {
          if (($Oip{$i} ne "")&&($Dis{$i} >0.0)){
            print "<input type=\"radio\" name=\"$i\" value=\"AGIP\" checked >AddGIP<BR>\n";
          }
        }

        print "</TD>";
        if ($Dis{$i}>0.8) { print "<TD ROWSPAN=4 bgcolor=#FF0000>\n";}
        elsif ($Dis{$i}>0.5) { print "<TD ROWSPAN=4 bgcolor=#FFFF00>\n";}
	     else {print "<TD ROWSPAN=4>\n";}
        print int($Dis{$i}*100),"</TD>";
        print "<TD>$year/$mon/$mday $hour:$min:$sec</TD></TR>\n";
        print "<TR><TD>$Sfrm{$i}</TD></TR>\n";
        print "<TR><TD><A href=\"$ME?FILE=$title/$i\"> $Subj{$i}</A></TD></TR>\n";
        print "<TR><TD>$Rfrm{$i}</TD></TR>\n";
        print "</TR>\n";
      }
      print( "</TABLE>");
      print( "</form method>\n");
    }
  }else{
    # TRASH
    print "<H4>$title</H4>\n";
    print $#result+1, "items\n";
    print "<form method=\"POST\" action=\"$ME\">";
    print "<input type=\"hidden\" name=\"DIR\" value=\"$title\" >\n";
    print "Past";
    
    print "<input type=\"radio\" name=\"DP\" value=\"1\"", ($DayTo eq 1)? "checked":"", ">1\n";
    print "<input type=\"radio\" name=\"DP\" value=\"2\"", ($DayTo eq 2)? "checked":"", ">2\n";
    print "<input type=\"radio\" name=\"DP\" value=\"3\"", ($DayTo eq 3)? "checked":"", ">3\n";
    print "<input type=\"radio\" name=\"DP\" value=\"4\"", ($DayTo eq 4)? "checked":"", ">4\n";
    print "<input type=\"radio\" name=\"DP\" value=\"5\"", ($DayTo eq 5)? "checked":"", ">5\n";
    print "<input type=\"radio\" name=\"DP\" value=\"6\"", ($DayTo eq 6)? "checked":"", ">6\n";
    print "<input type=\"radio\" name=\"DP\" value=\"7\"", ($DayTo eq 7)? "checked":"", ">7\n";
    
    print "(<input type=text name=\"DF\" size=2 value=$dayfrom >\n";
    print "-<input type=text name=\"DT\" size=2 value=$dayto >)\n";
    print "<input type=\"radio\" name=\"DP\" value=\"8\"",($DayTo >7)? "checked":"", "> Days.";
    print( "<input type=submit>");
    print( "<input type=reset>\n");
    
    if ($count>0){
      print( "<TABLE BORDER=4>\n");
      foreach $i (@result) {
        ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(substr($i,0,10));
        $mon += 1;
        $year+=1900;
        $Sfrm{$i}=encode('shiftjis', decode('MIME-Header',$Sfrm{$i}));
        ### For non-mime encoded from. Should be replaced #################
        if ($Sfrm{$i}=~ /^(.*)(.\$B.*\(B)(.*)$/){
          $one=$1;$two=$2;$c=$3; $c=~ s/</&lt;/g; $c=~ s/>/&gt;/g;
          $Sfrm{$i}=sprintf("%s%s%s",$one,$two,$c);
        }else{
	  $Sfrm{$i}=~ s/&/&amp;/g;
          $Sfrm{$i}=~ s/</&lt;/g;
	  $Sfrm{$i}=~ s/>/&gt;/g;
        }
        $Sfrm{$i}=encode('shiftjis',decode('Guess',$Sfrm{$i}));
        ####################################################################
        if ($Subj{$i}=~ /^=\?/) {$Subj{$i}=encode('shiftjis', decode('MIME-Header',$Subj{$i}));}
        if ($Subj{$i} =~ /^\s*$/) {
          $Subj{$i} = "**No Title**";
        }
        print "<TR><TD ROWSPAN=4>\n";
        print "<input type=\"radio\" name=\"$i\" value=\"R\">Nomal<BR>\n";
        if (($Oip{$i} ne "")&&($Dis{$i}<1.0)){
          print "<input type=\"radio\" name=\"$i\" value=\"ABIP\" checked >AddBIP<BR>\n";
        }
        print "</TD>";
        if ($Dis{$i}<0.3) { print "<TD ROWSPAN=4 bgcolor=#FF0000>\n";}
        elsif ($Dis{$i}<1.0) { print "<TD ROWSPAN=4 bgcolor=#FFFF00>\n";}
	     else {print "<TD ROWSPAN=4>\n";}
        print int($Dis{$i}*100),"</TD>";
        print "<TD>$year/$mon/$mday $hour:$min:$sec</TD></TR>\n";
        print "<TR><TD>$Sfrm{$i}</TD></TR>\n";
        $filename=$dir . $i;
        print "<TR><TD><A href=\"$ME?FILE=$title/$i\"> $Subj{$i}</A></TD></TR>\n";
        print "<TR><TD>$Rfrm{$i}</TD></TR>\n";
      }
      print( "</TABLE>");
    }
    print( "</form method>\n");
  }
}
