#!PERL_ABSOLUTE_PATH
#
#This file is part of NNIPF(Version 0.06-release):SPAM mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#############################################################################
#initialization
if (($start=rindex($0,"/")) >-1) {
        $ME=substr($0,$start+1);
        $Cmdpath=substr($0,0,$start);
}else{ $ME=$0; $Cmdpath=".";}
push @INC, "$Cmdpath/CONF", "$Cmdpath/PERL";
require 'conf.pl';
require 'analyze.pl';
require 'header.pl';
use Sys::Hostname;

HEADER::bRead($BOUNDARY);

if ($#ARGV > -1) {open IN,$ARGV[0] or die "$ARGV[0]:$!";}
else{ *IN = *STDIN;}

my $host = hostname(); chomp($host);
my $name=sprintf("%ld.%ld.%s",time(),$$,$host);
my $filename=sprintf("%s/%s",$TMP,$name);

my $header=HEADER::HeaderAnalysis(*IN,*Buf,1);

if (($header->{'lcount'}>3)&&($header->{'OIP'} ne "")) {
  if ($header->{'Dis'} < $T2){
    ######### GOOD
    open OUT,"> $filename" or die "$filename:$!";
    foreach $i  (@Buf){ print $i; print(OUT $i); }
    while (<IN>) { print $_; print(OUT $_);}
    close(OUT);
    $dfilename="$NEW/$name";
    rename $filename, $dfilename;
    if (ANALYZE::IsPrivate($header->{'OIP'}) eq 0) {
      ANALYZE::IpDictAdd($header->{'OIP'},$GOODIP);
    }
  }else{
    ######### BAD or Unknown
    open OUT,"> $filename" or die "$filename:$!";
    foreach $i  (@Buf){ print(OUT $i); }
    while (<IN>) { print(OUT $_);}
    close(OUT);
    if ($header->{'Dis'} > $T1) {
      ######### BAD
      $dfilename="$TRASH/$name";
      rename $filename, $dfilename;
      ANALYZE::IpDictAdd($header->{'OIP'},$BADIP);
    }
  }
}elsif ($header->{'lcount'}>3) {
  #### $header->{'OIP'}="" || lcount <=3
  open OUT,"> $filename" or die "$filename:$!";
  foreach $i  (@Buf){
    print(OUT $i);
  }
  while (<IN>) { print(OUT $_);}
  close(OUT);
}
if ($#ARGV > -1) {close(IN);}
